<template>
    <q-page class="bg-basel">
        <q-splitter v-model="splitter">
            <template #before>
                <div ref="parent" class="q-pa-md q-gutter-y-lg relative-position"
                     style="box-sizing:border-box; overflow: hidden; width: 95%;">
                    <q-resize-observer @resize="Resize"/>
                    <div :style="RectStyle" class="relative-position">
                        <img :src="backImage" style="width: 100%; height: 100%; z-index: 0">
                        <img :src="frontImage" ref="image" style=" z-index:-1"/>
                        <canvas ref="canvas" style="position: absolute; top: 0; left:0; z-index: 2" :style="CanvasStyle"/>
                    </div>
                </div>
                <div class="row q-gutter-x-md q-pa-md">
                    <q-btn @click="frontImageDialog  = true" label="choose front" color="primary"/>
                    <q-btn @click="backImageDialog = true" label="choose back" color="primary"/>
                    <q-btn @click="Export" label="Export" icon="export" color="positive"/>
                </div>

            </template>
            <template #after>
                <FormCore :fields="fields" v-model="model" :errors="errors" :has-error="hasErrors"/>
            </template>
        </q-splitter>
        <q-dialog v-model="frontImageDialog" persistent>
            <div class="bg-base q-pa-lg">
                <div class="column q-gutter-y-sm">

                    <div class="text-h5 text-weight-light ">
                        Please choose the image to crop
                    </div>
                    <Base64Uploader
                        color="teal"
                        flat
                        bordered
                        :on-upload="OnFrontImageUpload"
                        label="Upload a front image"
                        style="max-width: 300px"
                        @success="frontImageDialog = false"
                    />
                    <q-btn @click="frontImageDialog = false" color="secondary">
                        Back
                    </q-btn>
                </div>
            </div>

        </q-dialog>
        <q-dialog v-model="backImageDialog" persistent>
            <div class="bg-base q-pa-lg">
                <div class="column q-gutter-y-sm">

                    <div class="text-h5 text-weight-light ">
                        Please choose a image to compare against
                    </div>
                    <Base64Uploader
                        color="teal"
                        flat
                        bordered
                        :on-upload="OnBackImageUpload"
                        label="Upload a back image"
                        style="max-width: 300px"
                        @success="backImageDialog = false"
                    />
                    <q-btn @click="backImageDialog = false" color="secondary">
                        Back
                    </q-btn>
                </div>
            </div>

        </q-dialog>
    </q-page>
</template>

<script lang='ts'>
import {Component, Prop, Vue, Watch} from 'vue-property-decorator';
import {FormInput} from "src/classLibrary/FormTypes";
import FormCore from "components/FormCore.vue";
import Base64Uploader from "src/mixins/Base64Uploader";
// @ts-ignore
@Component({
    components: {Base64Uploader, FormCore}
})
export default class OverlayCropper extends Vue {

    @Prop() prop!: string
    splitter = 60

    numberRule: any = [(s: any) => !!s || 'required', (s: number) => s > 0 || 'needs to be positive'];

    w: number = 1;
    h: number = 1;

    backImage: string = '';
    frontImage: string = '';

    frontImageDialog = false;
    backImageDialog = false;

    OnFrontImageUpload(i: string[]) {
        this.frontImage = i[0];
    }

    OnBackImageUpload(i: string[]) {
        this.backImage = i[0];
    }


    Resize() {
        const p = (this.$refs['parent']) as Element;

        const w = p.getBoundingClientRect().width;
        const h = w / this.model.models.width * this.model.models.height;
        this.w = w;
        this.h = h;

    }

    get RectStyle() {
        return {
            width: this.w + "px",
            height: this.h + "px",
        }
    }


    @Watch('model', {deep: true, immediate: true})
    WatchModel() {
        this.Resize();
        this.draw();
    }

    @Watch('backImage', {deep: true, immediate: true})
    WatchBackImage() {
        this.draw();
    }

    @Watch('w', {deep: true, immediate: true})
    WatchW() {
        this.draw();
    }

    @Watch('h', {deep: true, immediate: true})
    WatchH() {
        this.draw();
    }

    get CanvasStyle() {
        return {
            ...this.RectStyle,
            opacity: this.model.models.alpha,
        }
    }

    draw() {
        const canvas = this.$refs.canvas as HTMLCanvasElement | null;
        const image = this.$refs.image as HTMLImageElement | null;

        const w = this.model.models.width;
        const h = this.model.models.height;

        const ctx = canvas?.getContext("2d");
        if (canvas != null && image != null) {
            canvas.width = image.width;
            canvas.height = image.width / w * h;

            const zoom = this.model.models.zoom.ToFloat();
            const top = this.model.models.top.ToFloat();
            const left = this.model.models.left.ToFloat();
            // const scale = (i: HTMLImageElement): HTMLCanvasElement => {
            //     const c = document.createElement('canvas');
            //     const ctx = c.getContext('2d');
            //     const w = i.width * zoom;
            //     const h = i.height * zoom;
            //     c.width = w;
            //     c.height = h;
            //     ctx?.drawImage(i, 0, 0, w, h);
            //     return c;
            // }
            // const scaled = scale(image);
            ctx?.clearRect(0, 0, canvas.width, canvas.height);
            ctx?.drawImage(image, left, top, image.width * zoom, image.height * zoom);
            // resample_single(canvas!, this.w, this.h, true)
        }
    }

    Export() {
        const link = document.createElement('a');
        const canvas = this.$refs.canvas as HTMLCanvasElement | null;
        if (canvas != null) {
            link.download = 'export.png';
            link.href = canvas?.toDataURL('image/png')
            link.click();
        }
        link.remove();
    }

    fields: FormInput[] = [
        {
            key: 'width',
            baseType: "number",
            icon: '',
            label: 'Width',
            tooltip: 'Width of the old floorplan',
            rules: this.numberRule,
        },
        {
            key: 'height',
            baseType: "number",
            icon: '',
            label: 'Height',
            tooltip: 'Height of the old floorplan',
            rules: this.numberRule,
        },
        {
            key: 'zoom',
            baseType: "number",
            icon: '',
            label: 'Zoom',
            tooltip: 'Zoom of new floorplan',
            rules: this.numberRule,
        },
        {
            key: 'top',
            baseType: "number",
            icon: '',
            label: 'offset top',
            tooltip: 'offset top',
        },
        {
            key: 'left',
            baseType: "number",
            icon: '',
            label: 'Offset left',
            tooltip: 'Offset left',
        },
        {
            key: 'alpha',
            baseType: "number",
            icon: '',
            label: 'New Floorplan transparency',
            tooltip: 'Transparency of the new floor',
            rules: this.numberRule,
        },
        {
            key: 'step',
            baseType: "number",
            icon: '',
            label: 'Step Pixels',
            tooltip: 'Step Pixels',
            rules: this.numberRule,
        },
    ]

    hasErrors = {
        step: false,
        alpha: false,
        left: false,
        top: false,
        zoom: false,
        height: false,
        width: false,
    }
    errors = {
        step: '',
        alpha: '',
        left: '',
        top: '',
        zoom: '',
        height: '',
        width: '',
    }
    model = {
        valid: false,
        models: {
            step: 1,
            alpha: 0.75,
            left: 0,
            top: 0,
            zoom: 1,
            height: 9,
            width: 16,
        }
    }

    move(event: KeyboardEvent) {


        if (event.keyCode == 37 || event.keyCode == 65) {
            this.$set(this.model.models, 'left', this.model.models.left.ToFloat() - this.model.models.step.ToFloat());
            event.preventDefault();
        } else if (event.keyCode == 39 || event.keyCode == 68) {
            this.$set(this.model.models, 'left', this.model.models.left.ToFloat() + this.model.models.step.ToFloat());
            event.preventDefault();
        } else if (event.keyCode == 38 || event.keyCode == 87) {
            this.$set(this.model.models, 'top', this.model.models.top.ToFloat() - this.model.models.step.ToFloat());
            event.preventDefault();
        } else if (event.keyCode == 40 || event.keyCode == 83) {
            this.$set(this.model.models, 'top', this.model.models.top.ToFloat() + this.model.models.step.ToFloat());
            event.preventDefault();
        }

    }

    created() {
        document.addEventListener('keydown', this.move);
    }

    destroyed() {
        document.removeEventListener('keydown', this.move);
    }
}
</script>

<style lang='scss' scoped>

</style>
